# CS699-Project

### Authors:
Meet Doshi 22m0742
Abuhujair Khan 22m0752

#### File Structure and Explanation
- Frontend backend Combined: 
```
<22m0742_22m0752>
├── dummy_data/ ~ Contains 4 csv files which should be loaded into the database.
├── frontend/
│   ├── sitcomm/
│      ├── node_modules/ ~ Libraries installed by npm used by angular
│      ├── src/
│         ├── apps/
│            ├── confluence/ ~ Confluence component
│            ├── github/ ~ Github component for files
│            ├── home/  ~ Home page for user which shows all projects
│            ├── jira/ ~ Jira component 
│            ├── login/ ~ Login component which also has register page.
│            ├── profile/ ~ Profile edit component.
│            ├── project/ ~ Individual component for each project.
│            └── other files which are moderately important
├── sitcomm/
│   ├── api/ ~ Child app which handles all APIs
│   ├── home/ ~ Home app which houses the models.
│   ├── onestop/ ~ Root app for django
│   └── manage.py ~ Run python3 manage.py runserver to start backend.
├── apis.txt ~ Contains info about all the APIs provided by Django and their functionality. For more info you can start the server and go to localhost:8000/api/xxx where it will give you ui based access to the api.
├── logfile ~ Ignore this, logfile used by postgres
├── README.md
├── requirements.txt ~ Use pip install -r requirements.txt
├── start-postgres.sh ~ Sample bash script to start postgres assuming its installed. Please modify file paths in the script.
└── readme.txt
```

#### Commands to run
0. `Install postgres, angular, material ui, node, npm, etc if not already there. Also insert data provided in dummy data folder after step 8.`
1. cd frontend/sitcomm/
2. npm install
3. cd ../../ 
4. pip install -r requirements.txt
5. sudo bash start-postgres.sh
6. cd sitcomm/
7. python3 manage.py makemigrations
8. python3 manage.py migrate
9. python3 manage.py runserver `Starts localhost backend server on http://127.0.0.1:8000/`
10. cd ../frontend/sitcomm/
11. npm serve --open `Starts localhost frontend server on http://127.0.0.1:4200/`


#### References:
`https://www.twilio.com/blog/build-progressive-web-application-django-angular-part-2-frontend-interface`